/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/msg/PR2GripperEventDetectorCommand.msg
 *
 */


#ifndef PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPEREVENTDETECTORCOMMAND_H
#define PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPEREVENTDETECTORCOMMAND_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace pr2_gripper_sensor_msgs
{
template <class ContainerAllocator>
struct PR2GripperEventDetectorCommand_
{
  typedef PR2GripperEventDetectorCommand_<ContainerAllocator> Type;

  PR2GripperEventDetectorCommand_()
    : trigger_conditions(0)
    , acceleration_trigger_magnitude(0.0)
    , slip_trigger_magnitude(0.0)  {
    }
  PR2GripperEventDetectorCommand_(const ContainerAllocator& _alloc)
    : trigger_conditions(0)
    , acceleration_trigger_magnitude(0.0)
    , slip_trigger_magnitude(0.0)  {
    }



   typedef int8_t _trigger_conditions_type;
  _trigger_conditions_type trigger_conditions;

   typedef double _acceleration_trigger_magnitude_type;
  _acceleration_trigger_magnitude_type acceleration_trigger_magnitude;

   typedef double _slip_trigger_magnitude_type;
  _slip_trigger_magnitude_type slip_trigger_magnitude;


    enum { FINGER_SIDE_IMPACT_OR_ACC = 0 };
     enum { SLIP_AND_ACC = 1 };
     enum { FINGER_SIDE_IMPACT_OR_SLIP_OR_ACC = 2 };
     enum { SLIP = 3 };
     enum { ACC = 4 };
 

  typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PR2GripperEventDetectorCommand_

typedef ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<std::allocator<void> > PR2GripperEventDetectorCommand;

typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand > PR2GripperEventDetectorCommandPtr;
typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand const> PR2GripperEventDetectorCommandConstPtr;

// constants requiring out of line definition

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_gripper_sensor_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'pr2_gripper_sensor_msgs': ['/tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/msg', '/tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/obj-x86_64-linux-gnu/devel/share/pr2_gripper_sensor_msgs/msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "b91a7e1e863671a84c1d06e0cac3146e";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xb91a7e1e863671a8ULL;
  static const uint64_t static_value2 = 0x4c1d06e0cac3146eULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_gripper_sensor_msgs/PR2GripperEventDetectorCommand";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# state variable that defines what events we would like to trigger on\n\
# Leaving this field blank will result in the robot triggering when \n\
# anything touches the sides of the finger or an impact is detected\n\
# with the hand/arm.\n\
int8 trigger_conditions\n\
# definitions for our various trigger_conditions values\n\
# trigger on either acceleration contact or finger sensor side impact\n\
int8 FINGER_SIDE_IMPACT_OR_ACC = 0\n\
# tigger once  both slip and acceleration signals occur\n\
int8 SLIP_AND_ACC = 1 \n\
#  trigger on either slip, acceleration, or finger sensor side impact\n\
int8 FINGER_SIDE_IMPACT_OR_SLIP_OR_ACC = 2\n\
# trigger only on slip information\n\
int8 SLIP = 3\n\
# trigger only on acceleration contact information\n\
int8 ACC = 4 \n\
\n\
\n\
# the amount of acceleration to trigger on (acceleration vector magnitude)\n\
# Units = m/s^2\n\
# The user needs to be concerned here about not setting the trigger too\n\
# low so that is set off by the robot's own motions.\n\
#\n\
# For large rapid motions, say by a motion planner, 5 m/s^2 is a good level\n\
# For small delicate controlled motions this can be set MUCH lower (try 2.0)\n\
#\n\
# NOTE: When moving the gripper joint (opening/closing the grippr)\n\
# the high gearing of the PR2 gripper causes large acceleration vibrations\n\
# which will cause triggering to occur. This is a known drawback of the PR2.\n\
#\n\
# NOTE: Leaving this value blank will result in a 0 m/s^2 trigger. If you\n\
# are using a trigger_conditions value that returns on acceleration contact\n\
# events then it will immediately exceed your trigger and return\n\
float64 acceleration_trigger_magnitude\n\
\n\
\n\
# the slip detector gain to trigger on (either finger) : try 0.01\n\
# higher values decrease slip sensitivty (to a point)\n\
# lower values increase sensitivity (to a point)\n\
#\n\
# NOTE: Leaving this value blank will result in the most sensitive slip level.\n\
float64 slip_trigger_magnitude\n\
";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.trigger_conditions);
      stream.next(m.acceleration_trigger_magnitude);
      stream.next(m.slip_trigger_magnitude);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PR2GripperEventDetectorCommand_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorCommand_<ContainerAllocator>& v)
  {
    s << indent << "trigger_conditions: ";
    Printer<int8_t>::stream(s, indent + "  ", v.trigger_conditions);
    s << indent << "acceleration_trigger_magnitude: ";
    Printer<double>::stream(s, indent + "  ", v.acceleration_trigger_magnitude);
    s << indent << "slip_trigger_magnitude: ";
    Printer<double>::stream(s, indent + "  ", v.slip_trigger_magnitude);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPEREVENTDETECTORCOMMAND_H
