/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/msg/PR2GripperEventDetectorData.msg
 *
 */


#ifndef PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPEREVENTDETECTORDATA_H
#define PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPEREVENTDETECTORDATA_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace pr2_gripper_sensor_msgs
{
template <class ContainerAllocator>
struct PR2GripperEventDetectorData_
{
  typedef PR2GripperEventDetectorData_<ContainerAllocator> Type;

  PR2GripperEventDetectorData_()
    : stamp()
    , trigger_conditions_met(false)
    , slip_event(false)
    , acceleration_event(false)
    , acceleration_vector()  {
      acceleration_vector.assign(0.0);
  }
  PR2GripperEventDetectorData_(const ContainerAllocator& _alloc)
    : stamp()
    , trigger_conditions_met(false)
    , slip_event(false)
    , acceleration_event(false)
    , acceleration_vector()  {
      acceleration_vector.assign(0.0);
  }



   typedef ros::Time _stamp_type;
  _stamp_type stamp;

   typedef uint8_t _trigger_conditions_met_type;
  _trigger_conditions_met_type trigger_conditions_met;

   typedef uint8_t _slip_event_type;
  _slip_event_type slip_event;

   typedef uint8_t _acceleration_event_type;
  _acceleration_event_type acceleration_event;

   typedef boost::array<double, 3>  _acceleration_vector_type;
  _acceleration_vector_type acceleration_vector;




  typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PR2GripperEventDetectorData_

typedef ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<std::allocator<void> > PR2GripperEventDetectorData;

typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData > PR2GripperEventDetectorDataPtr;
typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData const> PR2GripperEventDetectorDataConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_gripper_sensor_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'pr2_gripper_sensor_msgs': ['/tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/msg', '/tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/obj-x86_64-linux-gnu/devel/share/pr2_gripper_sensor_msgs/msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "9536d682ef6215440ecc47846d4117c2";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x9536d682ef621544ULL;
  static const uint64_t static_value2 = 0x0ecc47846d4117c2ULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_gripper_sensor_msgs/PR2GripperEventDetectorData";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Time the data was recorded at\n\
time stamp\n\
\n\
# true if the trigger conditions have been met \n\
# (see PR2GripperEventDetectorCommand)\n\
bool trigger_conditions_met\n\
\n\
# true if the pressure sensors detected a slip event\n\
# slip events occur when the finger pressure sensors\n\
# high-freq. content exceeds the slip_trigger_magnitude variable\n\
# (see PR2GripperEventDetectorCommand)\n\
bool slip_event\n\
\n\
# true if the hand-mounted accelerometer detected a contact acceleration\n\
# acceleration events occur when the palm accelerometer\n\
# high-freq. content exceeds the acc_trigger_magnitude variable\n\
# (see PR2GripperEventDetectorCommand)\n\
bool acceleration_event\n\
\n\
# the high-freq acceleration vector that was last seen (x,y,z)\n\
float64[3] acceleration_vector\n\
";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.stamp);
      stream.next(m.trigger_conditions_met);
      stream.next(m.slip_event);
      stream.next(m.acceleration_event);
      stream.next(m.acceleration_vector);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PR2GripperEventDetectorData_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_gripper_sensor_msgs::PR2GripperEventDetectorData_<ContainerAllocator>& v)
  {
    s << indent << "stamp: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.stamp);
    s << indent << "trigger_conditions_met: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.trigger_conditions_met);
    s << indent << "slip_event: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.slip_event);
    s << indent << "acceleration_event: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.acceleration_event);
    s << indent << "acceleration_vector[]" << std::endl;
    for (size_t i = 0; i < v.acceleration_vector.size(); ++i)
    {
      s << indent << "  acceleration_vector[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.acceleration_vector[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPEREVENTDETECTORDATA_H
