/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/msg/PR2GripperFindContactCommand.msg
 *
 */


#ifndef PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPERFINDCONTACTCOMMAND_H
#define PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPERFINDCONTACTCOMMAND_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace pr2_gripper_sensor_msgs
{
template <class ContainerAllocator>
struct PR2GripperFindContactCommand_
{
  typedef PR2GripperFindContactCommand_<ContainerAllocator> Type;

  PR2GripperFindContactCommand_()
    : zero_fingertip_sensors(false)
    , contact_conditions(0)  {
    }
  PR2GripperFindContactCommand_(const ContainerAllocator& _alloc)
    : zero_fingertip_sensors(false)
    , contact_conditions(0)  {
    }



   typedef uint8_t _zero_fingertip_sensors_type;
  _zero_fingertip_sensors_type zero_fingertip_sensors;

   typedef int8_t _contact_conditions_type;
  _contact_conditions_type contact_conditions;


    enum { BOTH = 0 };
     enum { LEFT = 1 };
     enum { RIGHT = 2 };
     enum { EITHER = 3 };
 

  typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PR2GripperFindContactCommand_

typedef ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<std::allocator<void> > PR2GripperFindContactCommand;

typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand > PR2GripperFindContactCommandPtr;
typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand const> PR2GripperFindContactCommandConstPtr;

// constants requiring out of line definition

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_gripper_sensor_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'pr2_gripper_sensor_msgs': ['/tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/msg', '/tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/obj-x86_64-linux-gnu/devel/share/pr2_gripper_sensor_msgs/msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "4a38a1a8e495aae86921ef2b292ec260";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x4a38a1a8e495aae8ULL;
  static const uint64_t static_value2 = 0x6921ef2b292ec260ULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_gripper_sensor_msgs/PR2GripperFindContactCommand";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# set true if you want to calibrate the fingertip sensors on the start\n\
# of the find_contact action. While this is not necessary (and\n\
# the default value will not calibrate the sensors) for best \n\
# performance it is recommended that you set this to true each time \n\
# you are calling find_contact and are confident the fingertips are \n\
# not touching anything\n\
# NOTE: SHOULD ONLY BE TRUE WHEN BOTH FINGERS ARE TOUCHING NOTHING\n\
bool zero_fingertip_sensors\n\
\n\
# the finger contact conditions that determine what our goal is\n\
# Leaving this field blank will result in the robot closing until\n\
# contact on BOTH fingers is achieved\n\
int8 contact_conditions\n\
\n\
# predefined values for the above contact_conditions variable\n\
int8 BOTH = 0   # both fingers must make contact\n\
int8 LEFT = 1   # just the left finger \n\
int8 RIGHT = 2  # just the right finger\n\
int8 EITHER = 3 # either finger, we don't care which\n\
";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.zero_fingertip_sensors);
      stream.next(m.contact_conditions);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PR2GripperFindContactCommand_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_gripper_sensor_msgs::PR2GripperFindContactCommand_<ContainerAllocator>& v)
  {
    s << indent << "zero_fingertip_sensors: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.zero_fingertip_sensors);
    s << indent << "contact_conditions: ";
    Printer<int8_t>::stream(s, indent + "  ", v.contact_conditions);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPERFINDCONTACTCOMMAND_H
