/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/msg/PR2GripperSensorRawData.msg
 *
 */


#ifndef PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPERSENSORRAWDATA_H
#define PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPERSENSORRAWDATA_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace pr2_gripper_sensor_msgs
{
template <class ContainerAllocator>
struct PR2GripperSensorRawData_
{
  typedef PR2GripperSensorRawData_<ContainerAllocator> Type;

  PR2GripperSensorRawData_()
    : stamp()
    , left_finger_pad_force(0.0)
    , right_finger_pad_force(0.0)
    , left_finger_pad_force_filtered(0.0)
    , right_finger_pad_force_filtered(0.0)
    , left_finger_pad_forces()
    , right_finger_pad_forces()
    , left_finger_pad_forces_filtered()
    , right_finger_pad_forces_filtered()
    , acc_x_raw(0.0)
    , acc_y_raw(0.0)
    , acc_z_raw(0.0)
    , acc_x_filtered(0.0)
    , acc_y_filtered(0.0)
    , acc_z_filtered(0.0)
    , left_contact(false)
    , right_contact(false)  {
      left_finger_pad_forces.assign(0.0);

      right_finger_pad_forces.assign(0.0);

      left_finger_pad_forces_filtered.assign(0.0);

      right_finger_pad_forces_filtered.assign(0.0);
  }
  PR2GripperSensorRawData_(const ContainerAllocator& _alloc)
    : stamp()
    , left_finger_pad_force(0.0)
    , right_finger_pad_force(0.0)
    , left_finger_pad_force_filtered(0.0)
    , right_finger_pad_force_filtered(0.0)
    , left_finger_pad_forces()
    , right_finger_pad_forces()
    , left_finger_pad_forces_filtered()
    , right_finger_pad_forces_filtered()
    , acc_x_raw(0.0)
    , acc_y_raw(0.0)
    , acc_z_raw(0.0)
    , acc_x_filtered(0.0)
    , acc_y_filtered(0.0)
    , acc_z_filtered(0.0)
    , left_contact(false)
    , right_contact(false)  {
      left_finger_pad_forces.assign(0.0);

      right_finger_pad_forces.assign(0.0);

      left_finger_pad_forces_filtered.assign(0.0);

      right_finger_pad_forces_filtered.assign(0.0);
  }



   typedef ros::Time _stamp_type;
  _stamp_type stamp;

   typedef double _left_finger_pad_force_type;
  _left_finger_pad_force_type left_finger_pad_force;

   typedef double _right_finger_pad_force_type;
  _right_finger_pad_force_type right_finger_pad_force;

   typedef double _left_finger_pad_force_filtered_type;
  _left_finger_pad_force_filtered_type left_finger_pad_force_filtered;

   typedef double _right_finger_pad_force_filtered_type;
  _right_finger_pad_force_filtered_type right_finger_pad_force_filtered;

   typedef boost::array<double, 22>  _left_finger_pad_forces_type;
  _left_finger_pad_forces_type left_finger_pad_forces;

   typedef boost::array<double, 22>  _right_finger_pad_forces_type;
  _right_finger_pad_forces_type right_finger_pad_forces;

   typedef boost::array<double, 22>  _left_finger_pad_forces_filtered_type;
  _left_finger_pad_forces_filtered_type left_finger_pad_forces_filtered;

   typedef boost::array<double, 22>  _right_finger_pad_forces_filtered_type;
  _right_finger_pad_forces_filtered_type right_finger_pad_forces_filtered;

   typedef double _acc_x_raw_type;
  _acc_x_raw_type acc_x_raw;

   typedef double _acc_y_raw_type;
  _acc_y_raw_type acc_y_raw;

   typedef double _acc_z_raw_type;
  _acc_z_raw_type acc_z_raw;

   typedef double _acc_x_filtered_type;
  _acc_x_filtered_type acc_x_filtered;

   typedef double _acc_y_filtered_type;
  _acc_y_filtered_type acc_y_filtered;

   typedef double _acc_z_filtered_type;
  _acc_z_filtered_type acc_z_filtered;

   typedef uint8_t _left_contact_type;
  _left_contact_type left_contact;

   typedef uint8_t _right_contact_type;
  _right_contact_type right_contact;




  typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PR2GripperSensorRawData_

typedef ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<std::allocator<void> > PR2GripperSensorRawData;

typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData > PR2GripperSensorRawDataPtr;
typedef boost::shared_ptr< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData const> PR2GripperSensorRawDataConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_gripper_sensor_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'pr2_gripper_sensor_msgs': ['/tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/msg', '/tmp/buildd/ros-hydro-pr2-gripper-sensor-msgs-1.0.8-0precise-20150602-2024/obj-x86_64-linux-gnu/devel/share/pr2_gripper_sensor_msgs/msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "696a1f2e6969deb0bc6998636ae1b17e";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x696a1f2e6969deb0ULL;
  static const uint64_t static_value2 = 0xbc6998636ae1b17eULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_gripper_sensor_msgs/PR2GripperSensorRawData";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# NOTE: This message is only for debugging purposes. It is not intended for API usage - and is not published under release code.\n\
\n\
# Standard ROS header\n\
time stamp\n\
\n\
# corrected for zero contact\n\
float64 left_finger_pad_force\n\
float64 right_finger_pad_force\n\
\n\
# filtered values : high pass filter at 5 Hz after correcting for zero contact\n\
float64 left_finger_pad_force_filtered\n\
float64 right_finger_pad_force_filtered\n\
\n\
# corrected for zero contact\n\
float64[22] left_finger_pad_forces\n\
float64[22] right_finger_pad_forces\n\
\n\
# filtered values : high pass filter at 5 Hz after correcting for zero contact\n\
float64[22] left_finger_pad_forces_filtered\n\
float64[22] right_finger_pad_forces_filtered\n\
\n\
# raw acceleration values\n\
float64 acc_x_raw\n\
float64 acc_y_raw\n\
float64 acc_z_raw\n\
\n\
# filtered acceleration values\n\
float64 acc_x_filtered\n\
float64 acc_y_filtered\n\
float64 acc_z_filtered\n\
\n\
# boolean variables indicating whether contact exists or not\n\
bool left_contact\n\
bool right_contact\n\
";
  }

  static const char* value(const ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.stamp);
      stream.next(m.left_finger_pad_force);
      stream.next(m.right_finger_pad_force);
      stream.next(m.left_finger_pad_force_filtered);
      stream.next(m.right_finger_pad_force_filtered);
      stream.next(m.left_finger_pad_forces);
      stream.next(m.right_finger_pad_forces);
      stream.next(m.left_finger_pad_forces_filtered);
      stream.next(m.right_finger_pad_forces_filtered);
      stream.next(m.acc_x_raw);
      stream.next(m.acc_y_raw);
      stream.next(m.acc_z_raw);
      stream.next(m.acc_x_filtered);
      stream.next(m.acc_y_filtered);
      stream.next(m.acc_z_filtered);
      stream.next(m.left_contact);
      stream.next(m.right_contact);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PR2GripperSensorRawData_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_gripper_sensor_msgs::PR2GripperSensorRawData_<ContainerAllocator>& v)
  {
    s << indent << "stamp: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.stamp);
    s << indent << "left_finger_pad_force: ";
    Printer<double>::stream(s, indent + "  ", v.left_finger_pad_force);
    s << indent << "right_finger_pad_force: ";
    Printer<double>::stream(s, indent + "  ", v.right_finger_pad_force);
    s << indent << "left_finger_pad_force_filtered: ";
    Printer<double>::stream(s, indent + "  ", v.left_finger_pad_force_filtered);
    s << indent << "right_finger_pad_force_filtered: ";
    Printer<double>::stream(s, indent + "  ", v.right_finger_pad_force_filtered);
    s << indent << "left_finger_pad_forces[]" << std::endl;
    for (size_t i = 0; i < v.left_finger_pad_forces.size(); ++i)
    {
      s << indent << "  left_finger_pad_forces[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.left_finger_pad_forces[i]);
    }
    s << indent << "right_finger_pad_forces[]" << std::endl;
    for (size_t i = 0; i < v.right_finger_pad_forces.size(); ++i)
    {
      s << indent << "  right_finger_pad_forces[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.right_finger_pad_forces[i]);
    }
    s << indent << "left_finger_pad_forces_filtered[]" << std::endl;
    for (size_t i = 0; i < v.left_finger_pad_forces_filtered.size(); ++i)
    {
      s << indent << "  left_finger_pad_forces_filtered[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.left_finger_pad_forces_filtered[i]);
    }
    s << indent << "right_finger_pad_forces_filtered[]" << std::endl;
    for (size_t i = 0; i < v.right_finger_pad_forces_filtered.size(); ++i)
    {
      s << indent << "  right_finger_pad_forces_filtered[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.right_finger_pad_forces_filtered[i]);
    }
    s << indent << "acc_x_raw: ";
    Printer<double>::stream(s, indent + "  ", v.acc_x_raw);
    s << indent << "acc_y_raw: ";
    Printer<double>::stream(s, indent + "  ", v.acc_y_raw);
    s << indent << "acc_z_raw: ";
    Printer<double>::stream(s, indent + "  ", v.acc_z_raw);
    s << indent << "acc_x_filtered: ";
    Printer<double>::stream(s, indent + "  ", v.acc_x_filtered);
    s << indent << "acc_y_filtered: ";
    Printer<double>::stream(s, indent + "  ", v.acc_y_filtered);
    s << indent << "acc_z_filtered: ";
    Printer<double>::stream(s, indent + "  ", v.acc_z_filtered);
    s << indent << "left_contact: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.left_contact);
    s << indent << "right_contact: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.right_contact);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_GRIPPER_SENSOR_MSGS_MESSAGE_PR2GRIPPERSENSORRAWDATA_H
